## kaidan 0.7.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)
set(CMAKE_CXX_STANDARD 17)
set(QT_MIN_VERSION "5.14.0")
set(KF5_MIN_VERSION "5.67.0")

if(POLICY CMP0071)
	cmake_policy(SET CMP0071 NEW)
endif()

project(kaidan)

# application information
set(APPLICATION_ID "im.kaidan.kaidan")
set(APPLICATION_NAME "kaidan")
set(APPLICATION_DISPLAY_NAME "Kaidan")
set(APPLICATION_DESCRIPTION "A simple, user-friendly Jabber/XMPP client for every device!")
if(UBUNTU_TOUCH)
	set(APPLICATION_NAME "${APPLICATION_ID}")
endif()

# Version
set(VERSION_MAJOR 0)
set(VERSION_MINOR 7)
set(VERSION_PATCH 0)
set(VERSION_CODE 11)
set(VERSION_EXTRA "" CACHE STRING "Stuff to append to version string")

set(DEVELOPMENT_BUILD FALSE)
if(DEVELOPMENT_BUILD)
	set(VERSION_EXTRA "${VERSION_EXTRA}-dev")
endif()

set(VERSION_STRING "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
if(VERSION_EXTRA)
	set(VERSION_STRING ${VERSION_STRING}${VERSION_EXTRA})
endif()

# CMake options
option(I18N "Enable i18n support" FALSE)
option(BUILD_TESTS "Build unit tests" FALSE)
option(STATIC_BUILD "Build Kaidan statically")
option(APPIMAGE "Build Kaidan as AppImage (will only work in the appimage script)" FALSE)
option(UBUNTU_TOUCH "Building an Ubuntu Touch click (internal use only!)" FALSE)
option(CLICK_ARCH "Architecture that will be used in the click's manifest")
option(CLICK_DATE "Date used in the version number in the click's manifest")
option(QUICK_COMPILER "Use QtQuick compiler to improve performance" FALSE)
option(USE_KNOTIFICATIONS "Use KNotifications for displaying notifications" TRUE)
option(BUNDLE_ICONS "Bundle breeze icons" FALSE)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Instruct CMake to run moc, uic and rcc automatically when needed.
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(AUTOMOC_MOC_OPTIONS -Muri=${APPLICATION_ID})

#
# Dependecies
#

find_package(ECM 5.40.0 REQUIRED NO_MODULE)

# CMake module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})

# CMake modules include
include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)
include(ECMInstallIcons)
include(FeatureSummary)
kde_enable_exceptions()

# Find packages
find_package(Qt5 ${QT_MIN_VERSION} REQUIRED NO_MODULE COMPONENTS Core Qml Quick Svg Sql QuickControls2 Xml Multimedia Positioning Location)
find_package(KF5Kirigami2 ${KF5_MIN_VERSION} REQUIRED)
find_package(ZXing REQUIRED)
find_package(QXmpp 1.2.0 REQUIRED)

# Optional QtQuickCompiler
if(QUICK_COMPILER)
	find_package(Qt5QuickCompiler)
	set_package_properties(Qt5QuickCompiler PROPERTIES
		DESCRIPTION "Compile QML at build time"
		TYPE OPTIONAL
	)
endif()

if(USE_KNOTIFICATIONS)
	find_package(KF5Notifications REQUIRED)
	set(__KF5Notifications_LIBRARIES KF5::Notifications)
	add_definitions(-DHAVE_KNOTIFICATIONS)
endif()

# Optional QWidget style integration (not on mobile)
if(NOT UBUNTU_TOUCH AND NOT ANDROID AND NOT IOS)
	find_package(Qt5Widgets)
	find_package(KF5QQC2DeskopStyle)
	set_package_properties(Qt5Widgets PROPERTIES
		DESCRIPTION "Integration with QWidget based desktop styles"
		TYPE OPTIONAL
	)
endif()

# Platform-specific
if(Qt5Widgets_FOUND)
	add_definitions(-DHAVE_QWIDGETS -DQAPPLICATION_CLASS=QApplication)
	set(__Qt5Widgets_LIBRARIES Qt5::Widgets)
else()
	add_definitions(-DQAPPLICATION_CLASS=QGuiApplication)
endif()

if(ANDROID)
	find_package(Qt5 REQUIRED COMPONENTS AndroidExtras)
endif()

if(ANDROID)
	find_package(PkgConfig REQUIRED)
	pkg_search_module(OPENSSL REQUIRED openssl IMPORTED_TARGET)
	message(STATUS "Using OpenSSL ${OPENSSL_VERSION}")
endif()


#
# Load submodules
#

# Main kaidan sources
include("${CMAKE_SOURCE_DIR}/src/CMakeLists.txt")

# I18n support
if(I18N)
	include("${CMAKE_SOURCE_DIR}/i18n/CMakeLists.txt")
endif()


#
# Sources / Resources
#

# Include bundled icons on Ubuntu Touch, Android, Windows, macOS and iOS
if(BUNDLE_ICONS OR UBUNTU_TOUCH OR ANDROID)
	set(KAIDAN_ICONS_QRC kirigami-icons.qrc)
endif()

# Bundled knotifications configuration files on platforms that require it
if(ANDROID)
	set(KAIDAN_NOTIFICATIONS_QRC "misc/notifications.qrc")
endif()

# Bundle images on Android, Windows, macOS and iOS
if(ANDROID OR WIN32 OR APPLE)
	set(KAIDAN_IMAGES_QRC "data/images/images.qrc")
endif()

# Set app icon
include(ECMAddAppIcon)
file(GLOB ICONS_SRCS "${CMAKE_SOURCE_DIR}/misc/app-icons/*kaidan.png")
message(STATUS ${ICONS_SRCS})
ecm_add_app_icon(KAIDAN_ICNS ICONS ${ICONS_SRCS})
message(STATUS ${KAIDAN_ICNS})

if(QUICK_COMPILER)
	qtquick_compiler_add_resources(KAIDAN_QML_QRC src/qml/qml.qrc)
else()
	qt5_add_resources(KAIDAN_QML_QRC src/qml/qml.qrc)
endif()

# misc resources (e.g. qtquickcontrols2.conf)
qt5_add_resources(KAIDAN_MISC_QRC misc/misc.qrc)

add_executable(${PROJECT_NAME}
	WIN32
	${KAIDAN_ICNS}
	${KAIDAN_SOURCES}
	${KAIDAN_QML_QRC}
	${KAIDAN_MISC_QRC}
	${KAIDAN_ICONS_QRC}          # only set if enabled
	${KAIDAN_IMAGES_QRC}         #
	${I18N_QRC_CPP}              #
	${KAIDAN_NOTIFICATIONS_QRC}  #
	"data/data.qrc"
)

target_link_libraries(${PROJECT_NAME}
	Qt5::Core
	Qt5::Sql
	Qt5::Qml
	Qt5::Quick
	Qt5::Svg
	Qt5::Network
	Qt5::Xml
	Qt5::Multimedia
	Qt5::Positioning
	Qt5::Location
	Qt5::QuickControls2
	QXmpp::QXmpp
	${__Qt5Widgets_LIBRARIES}
	${__KF5Notifications_LIBRARIES}
)
if(TARGET ZXing::ZXing)
        target_link_libraries(${PROJECT_NAME} ZXing::ZXing)
elseif(TARGET ZXing::Core)
        target_link_libraries(${PROJECT_NAME} ZXing::Core)
endif()

if(ANDROID OR IOS)
	target_link_libraries(${PROJECT_NAME} Qt5::QuickControls2 KF5::Kirigami2)
endif()

if(ANDROID)
	target_link_libraries(${PROJECT_NAME} PkgConfig::OPENSSL)
endif()

if(ANDROID)
	target_link_libraries(${PROJECT_NAME} Qt5::AndroidExtras)
endif()

if(STATIC_BUILD)
	add_definitions(-DQXMPP_BUILD)

	find_package(Perl REQUIRED)

	set(STATIC_DEPENDENCIES_CMAKE_FILE "${CMAKE_BINARY_DIR}/QtStaticDependencies.cmake")
	if(EXISTS ${STATIC_DEPENDENCIES_CMAKE_FILE})
		file(REMOVE ${STATIC_DEPENDENCIES_CMAKE_FILE})
	endif()

	get_target_property(QT_LIBDIR Qt5::Core LOCATION)
	get_filename_component(QT_LIBDIR ${QT_LIBDIR} DIRECTORY)

	macro(CONVERT_PRL_LIBS_TO_CMAKE _qt_component)
		if(TARGET Qt5::${_qt_component})
			get_target_property(_lib_location Qt5::${_qt_component} LOCATION)
			execute_process(COMMAND ${PERL_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/utils/convert-prl-libs-to-cmake.pl
				--lib ${_lib_location}
				--libdir ${QT_LIBDIR}
				--out ${STATIC_DEPENDENCIES_CMAKE_FILE}
				--component ${_qt_component}
				--compiler ${CMAKE_CXX_COMPILER_ID}
			)
		endif()
	endmacro()

	link_directories(${_qt5_install_prefix}/../)

	foreach(qt_module Gui Quick QuickControls2 Network Qml Svg Sql QSQLiteDriverPlugin
             QJpegPlugin QGifPlugin QSvgPlugin QSvgIconPlugin QICOPlugin QGenericEnginePlugin
	         QLocalClientConnectionFactory QTcpServerConnectionFactory)
		CONVERT_PRL_LIBS_TO_CMAKE(${qt_module})
	endforeach()

	if(IOS)
		foreach(qt_module QIOSIntegrationPlugin QMacHeifPlugin QMacJp2Plugin
			QICNSPlugin QTgaPlugin QTiffPlugin QWbmpPlugin QWebpPlugin)
			CONVERT_PRL_LIBS_TO_CMAKE(${qt_module})
		endforeach()
	endif()

	if(NOT EXISTS ${STATIC_DEPENDENCIES_CMAKE_FILE})
		message(FATAL_ERROR "Unable to find ${STATIC_DEPENDENCIES_CMAKE_FILE}")
	endif()
	include(${STATIC_DEPENDENCIES_CMAKE_FILE})

	set(QT_QML_PATH ${_qt5Quick_install_prefix})

	find_library(KIRIGAMI_PLUGIN kirigamiplugin PATHS ${Kirigami2_INSTALL_PREFIX}/${KDE_INSTALL_QMLDIR}/org/kde/kirigami.2)
	find_library(QUICK_PLUGIN qtquick2plugin PATHS ${QT_QML_PATH}/qml/QtQuick.2)
	find_library(LABS_PLATFORM_PLUGIN qtlabsplatformplugin PATHS ${QT_QML_PATH}/qml/Qt/labs/platform)
	find_library(GRAPHEFFECTS_PLUGIN qtgraphicaleffectsplugin PATHS ${QT_QML_PATH}/qml/QtGraphicalEffects)
	find_library(GRAPHEFFECTS_PRIVATE_PLUGIN qtgraphicaleffectsprivate PATHS ${QT_QML_PATH}/qml/QtGraphicalEffects/private)
	find_library(QQC2_PLUGIN qtquickcontrols2plugin PATHS ${QT_QML_PATH}/qml/QtQuick/Controls.2)
	find_library(QQC2_MATERIAL_PLUGIN qtquickcontrols2materialstyleplugin PATHS ${QT_QML_PATH}/qml/QtQuick/Controls.2/Material)
	find_library(QQC2_UNIVERSAL_PLUGIN qtquickcontrols2universalstyleplugin PATHS ${QT_QML_PATH}/qml/QtQuick/Controls.2/Universal)
	find_library(QLAYOUTS_PLUGIN qquicklayoutsplugin PATHS ${QT_QML_PATH}/qml/QtQuick/Layouts)
	find_library(QWINDOW_PLUGIN windowplugin PATHS ${QT_QML_PATH}/qml/QtQuick/Window.2)
	find_library(QSHAPES_PLUGIN qmlshapesplugin PATHS ${QT_QML_PATH}/qml/QtQuick/Shapes)
	find_library(QUICKSHAPES Qt5QuickShapes PATHS ${QT_LIBDIR})
	find_library(QTEMPLATES_PLUGIN qtquicktemplates2plugin PATHS ${QT_QML_PATH}/qml/QtQuick/Templates.2)
	find_library(QMODELS_PLUGIN modelsplugin PATHS ${QT_QML_PATH}/qml/QtQml/Models.2)
	target_link_libraries(${PROJECT_NAME}
		${plugin_libs}
		Qt5::QSQLiteDriverPlugin
		Qt5::QJpegPlugin
		Qt5::QGifPlugin
		Qt5::QSvgPlugin
		Qt5::QSvgIconPlugin
		Qt5::QICOPlugin
		Qt5::QGenericEnginePlugin
		Qt5::QLocalClientConnectionFactory
		Qt5::QTcpServerConnectionFactory
		${KIRIGAMI_PLUGIN}
		${QUICK_PLUGIN}
		${LABS_PLATFORM_PLUGIN}
		${GRAPHEFFECTS_PLUGIN}
		${GRAPHEFFECTS_PRIVATE_PLUGIN}
		${QQC2_PLUGIN}
		${QQC2_MATERIAL_PLUGIN}
		${QQC2_UNIVERSAL_PLUGIN}
		${QLAYOUTS_PLUGIN}
		${QWINDOW_PLUGIN}
		${QSHAPES_PLUGIN}
		${QUICKSHAPES}
		${QTEMPLATES_PLUGIN}
		${QMODELS_PLUGIN}
		${__Qt5Widgets_LIBRARIES}
	)

	if(IOS)
		target_link_libraries(${PROJECT_NAME}
			Qt5::QIOSIntegrationPlugin
			Qt5::QMacHeifPlugin
			Qt5::QMacJp2Plugin
			Qt5::QICNSPlugin
			Qt5::QTgaPlugin
			Qt5::QTiffPlugin
			Qt5::QWbmpPlugin
			Qt5::QWebpPlugin
		)
	endif()
endif()

# Set a custom plist file for the app bundle
if(APPLE)
	if(IOS)
		set_target_properties(${PROJECT_NAME} PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_SOURCE_DIR}/misc/ios/Info.plist)
	else()
		set_target_properties(${PROJECT_NAME} PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_SOURCE_DIR}/misc/macos/Info.plist)
	endif()
endif()

# iOS-specific linker flags
if(IOS)
	set(CMAKE_EXE_LINKER_FLAGS ${CMAKE_EXE_LINKER_FLAGS} "-Wl,-e,_qt_main_wrapper -u _qt_registerPlatformPlugin")
endif()

#
# Global C++ variables
#

if(UBUNTU_TOUCH)
	set(KAIDAN_COMPILE_DEFINITIONS UBUNTU_TOUCH=True)
elseif(APPIMAGE)
	set(KAIDAN_COMPILE_DEFINITIONS
		APPIMAGE=True
		TARGET_GSTREAMER_PLUGINS="${TARGET_GSTREAMER_PLUGINS}"
	)
endif()

if(STATIC_BUILD)
	set(KAIDAN_COMPILE_DEFINITIONS
		STATIC_BUILD=True
		${KAIDAN_COMPILE_DEFINITIONS}
	)
endif()

target_compile_definitions(${PROJECT_NAME} PRIVATE
	DEBUG_SOURCE_PATH="${CMAKE_SOURCE_DIR}"
	VERSION_STRING="${VERSION_STRING}"
	APPLICATION_ID="${APPLICATION_ID}"
	APPLICATION_NAME="${APPLICATION_NAME}"
	APPLICATION_DISPLAY_NAME="${APPLICATION_DISPLAY_NAME}"
	APPLICATION_DESCRIPTION="${APPLICATION_DESCRIPTION}"

	${KAIDAN_COMPILE_DEFINITIONS}
)

#
# Install Kaidan
#

if(ANDROID)
	configure_file(${CMAKE_SOURCE_DIR}/misc/android/AndroidManifest.xml.in
	               ${CMAKE_SOURCE_DIR}/misc/android/AndroidManifest.xml)
elseif(IOS)
	configure_file(${CMAKE_SOURCE_DIR}/misc/ios/Info.plist.in
	               ${CMAKE_SOURCE_DIR}/misc/ios/Info.plist)
endif()

if(UBUNTU_TOUCH AND CLICK_ARCH)
	set(CLICK_VERSION ${VERSION_STRING})
	if(DEVELOPMENT_BUILD)
		set(CLICK_VERSION "${CLICK_VERSION}.${CLICK_DATE}")
	endif()

	# will replace ${CLICK_ARCH} with its value
	configure_file(${CMAKE_SOURCE_DIR}/misc/ubuntu-touch/manifest.json.in
	               ${CMAKE_SOURCE_DIR}/misc/ubuntu-touch/manifest.json)

	# install kaidan binary
	install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/bin/${PROJECT_NAME}
	        DESTINATION ${CMAKE_INSTALL_PREFIX}
	)
	# install kaidan media
	install(DIRECTORY "data/"
	        DESTINATION "${CMAKE_INSTALL_FULL_DATADIR}/${APPLICATION_ID}"
		PATTERN "*.qrc" EXCLUDE
	)
	# install icon
	install(FILES "data/images/kaidan.svg" "misc/ubuntu-touch/apparmor.json"
	              "misc/ubuntu-touch/kaidan.desktop" "misc/ubuntu-touch/manifest.json"
	        DESTINATION "${CMAKE_INSTALL_PREFIX}"
	)

=== src/CMakeLists.txt ===
# set Kaidans sources (used in main cmake file)
set(KAIDAN_SOURCES
	src/main.cpp
	src/Kaidan.cpp
	src/ClientWorker.cpp
	src/AvatarFileStorage.cpp
	src/Database.cpp
	src/RosterItem.cpp
	src/RosterModel.cpp
	src/RosterFilterProxyModel.cpp
	src/RosterDb.cpp
	src/RosterManager.cpp
	src/RegistrationManager.cpp
	src/Message.cpp
	src/MessageModel.cpp
	src/MessageDb.cpp
	src/MessageHandler.cpp
	src/Notifications.cpp
	src/PresenceCache.cpp
	src/UserDevicesModel.cpp
	src/DiscoveryManager.cpp
	src/VCardManager.cpp
	src/VCardModel.cpp
	src/LogHandler.cpp
	src/StatusBar.cpp
	src/UploadManager.cpp
	src/EmojiModel.cpp
	src/TransferCache.cpp
	src/DownloadManager.cpp
	src/ServerFeaturesCache.cpp
	src/QmlUtils.cpp
	src/Utils.cpp
	src/VersionManager.cpp
	src/QrCodeDecoder.cpp
	src/QrCodeGenerator.cpp
	src/QrCodeScannerFilter.cpp
	src/QrCodeVideoFrame.cpp
	src/CameraModel.cpp
	src/AudioDeviceModel.cpp
	src/MediaSettings.cpp
	src/CameraImageCapture.cpp
	src/MediaUtils.cpp
	src/MediaRecorder.cpp
	src/CredentialsGenerator.cpp
	src/CredentialsValidator.cpp
	src/BitsOfBinaryImageProvider.cpp
	src/DataFormModel.cpp
	src/RegistrationDataFormFilterModel.cpp
	src/RegistrationDataFormModel.cpp
	src/ServerListModel.cpp
	src/ServerListItem.cpp
	src/AccountManager.cpp

	# needed to trigger moc generation / to be displayed in IDEs
	src/Enums.h
	src/Globals.h
	src/GuiStyle.h

	# kaidan QXmpp extensions (need to be merged into QXmpp upstream)
	src/qxmpp-exts/QXmppUploadManager.cpp
	src/qxmpp-exts/QXmppColorGenerator.cpp
	src/qxmpp-exts/QXmppUri.cpp

	# hsluv-c required for color generation
	src/hsluv-c/hsluv.c
)

if(NOT ANDROID AND NOT IOS)
	set(KAIDAN_SOURCES ${KAIDAN_SOURCES}
		src/singleapp/singleapplication.cpp
		src/singleapp/singleapplication_p.cpp
	)
endif()

=== debian/changelog ===
kaidan (0.7.0-1) unstable; urgency=medium

  * New upstream release (0.7.0):
    - Features:
       o Display client information (name, version, OS) of contacts (jbb, lnj)
       o Drag'n'drop for sending files (jbb)
       o Allow pasting images from the clipboard (Ctrl+Shift+V) into the chat
         (jbb)
       o Allow inserting newlines using Shift+Enter (jbb)
       o Add configuration of custom hostname/port (jbb, melvo)
       o Favourite emojis are shown by default now (melvo)
       o Search emojis by ":<name>" (melvo)
       o Display connection errors in the global drawer after login (melvo)
       o Improved design of media preview sheets (jbb)
       o Restructure message sending bar (melvo)
   - Bugfixes:
       o Do not interpret random URLs as files anymore (lnj)
       o Fix the style of buttons when using Material style (melvo)
       o Fix file dialog and media drawer opening in some cases (melvo)
       o Fix opening of the LoginPage when scanning QR code without password
         (melvo)
  * Add Debian XMPP Maintainers to the uploaders at their request.
  * Update build dependencies according to the upstream build system:
    - Qt >= 5.14
    - add qml-module-org-kde-qqc2desktopstyle to runtime dependencies
  * Refresh copyright information.
  * Update watch file to point to new release location.

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 02 Feb 2021 19:40:30 +0100

kaidan (0.6.0-2) unstable; urgency=medium

  * Release to unstable.
  * Add missing build dependency to libgstreamer1.0-dev.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 06 Jan 2021 08:12:41 +0100

kaidan (0.6.0-1) experimental; urgency=medium

  * Initial release (Closes: #976376)

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 15 Dec 2020 22:41:50 +0100

=== debian/control ===
Source: kaidan
Section: net
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>,
Build-Depends: cmake (>= 3.3~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.40.0~),
               libgstreamer1.0-dev,
               libkf5notifications-dev (>= 5.67.0~),
               libqxmpp-dev (>= 1.2.0~),
               libqt5svg5-dev (>= 5.14.0~),
               libzxingcore-dev,
               kirigami2-dev (>= 5.67.0~),
               pkg-kde-tools,
               qtbase5-dev (>= 5.14.0~),
               qtlocation5-dev (>= 5.14.0~),
               qtmultimedia5-dev (>= 5.14.0~),
               qtpositioning5-dev (>= 5.14.0~),
               qtquickcontrols2-5-dev (>= 5.14.0~),
               qttools5-dev (>= 5.14.0~),
Standards-Version: 4.5.1
Homepage: https://www.kaidan.im/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kaidan
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kaidan.git
Rules-Requires-Root: no

Package: kaidan
Architecture: any
Depends: qml-module-org-kde-kirigami2 (>= 5.67.0~),
         qml-module-org-kde-qqc2desktopstyle (>= 5.67.0~),
         qml-module-qtgraphicaleffects (>= 5.14.0~),
         qml-module-qtlocation (>= 5.14.0~),
         qml-module-qtmultimedia (>= 5.14.0~),
         qml-module-qtpositioning (>= 5.14.0~),
         qml-module-qtqml (>= 5.14.0~),
         qml-module-qtquick-controls2 (>= 5.14.0~),
         qml-module-qtquick-dialogs (>= 5.14.0~),
         qml-module-qtquick-layouts (>= 5.14.0~),
         qml-module-qtquick2 (>= 5.14.0~),
         ${shlibs:Depends},
         ${misc:Depends},
Description: Simple and user-friendly Jabber/XMPP client
 Kaidan is a simple, user-friendly and modern chat client. It uses the open
 communication protocol XMPP (Jabber).
 .
 The user interface makes use of Kirigami and QtQuick, while the back-end of
 Kaidan is entirely written in C++ using Qt and the Qt-based XMPP library
 QXmpp.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -- -DI18N=TRUE

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ https://download.kde.org/unstable/@PACKAGE@/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@

## kaidan 0.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,9 +20,9 @@
 
 # Version
 set(VERSION_MAJOR 0)
-set(VERSION_MINOR 7)
+set(VERSION_MINOR 8)
 set(VERSION_PATCH 0)
-set(VERSION_CODE 11)
+set(VERSION_CODE 12)
 set(VERSION_EXTRA "" CACHE STRING "Stuff to append to version string")
 
 set(DEVELOPMENT_BUILD FALSE)
@@ -74,10 +74,10 @@
 kde_enable_exceptions()
 
 # Find packages
-find_package(Qt5 ${QT_MIN_VERSION} REQUIRED NO_MODULE COMPONENTS Core Qml Quick Svg Sql QuickControls2 Xml Multimedia Positioning Location)
+find_package(Qt5 ${QT_MIN_VERSION} REQUIRED NO_MODULE COMPONENTS Core Concurrent Qml Quick Svg Sql QuickControls2 Xml Multimedia Positioning Location)
 find_package(KF5Kirigami2 ${KF5_MIN_VERSION} REQUIRED)
 find_package(ZXing REQUIRED)
-find_package(QXmpp 1.2.0 REQUIRED)
+find_package(QXmpp 1.3.0 REQUIRED)
 
 # Optional QtQuickCompiler
 if(QUICK_COMPILER)
@@ -97,7 +97,7 @@
 # Optional QWidget style integration (not on mobile)
 if(NOT UBUNTU_TOUCH AND NOT ANDROID AND NOT IOS)
 	find_package(Qt5Widgets)
-	find_package(KF5QQC2DeskopStyle)
+	find_package(KF5QQC2DesktopStyle)
 	set_package_properties(Qt5Widgets PROPERTIES
 		DESCRIPTION "Integration with QWidget based desktop styles"
 		TYPE OPTIONAL

=== i18n/CMakeLists.txt ===
# Kaidan i18n

find_package(Qt5LinguistTools)

file(GLOB FILES_TO_TRANSLATE
	${CMAKE_SOURCE_DIR}/src/*.cpp
	${CMAKE_SOURCE_DIR}/src/qml/*.qml
	${CMAKE_SOURCE_DIR}/src/qml/elements/*.qml
	${CMAKE_SOURCE_DIR}/src/qml/settings/*.qml
)
file(GLOB TS_FILES
	${CMAKE_CURRENT_LIST_DIR}/*.ts
)


#
# Update TS-files
#

set(LUPDATE_ARGS -silent)

foreach(TS_FILE ${TS_FILES})
add_custom_command(
	OUTPUT ${TS_FILE}
	COMMAND ${Qt5_LUPDATE_EXECUTABLE} ${LUPDATE_ARGS} ${FILES_TO_TRANSLATE} -ts ${TS_FILE}
	COMMENT "Updating ${TS_FILE}"
	MAIN_DEPENDENCY ${FILES_TO_TRANSLATE}
	DEPENDS ${FILES_TO_TRANSLATE}
	VERBATIM
)
endforeach()

# extra target for *only* updating ts files
add_custom_target(ts_update)
foreach(TS_FILE ${TS_FILES})
add_custom_command(
	TARGET ts_update
	COMMAND ${Qt5_LUPDATE_EXECUTABLE} ${LUPDATE_ARGS} ${FILES_TO_TRANSLATE} -ts ${TS_FILE}
	COMMENT "Updating ${TS_FILE}"
)
endforeach()


#
# Generate QM-files
#

set(LRELEASE_ARGS -compress -nounfinished -removeidentical -silent)

foreach(TS_FILE ${TS_FILES})
get_filename_component(FILENAME ${TS_FILE} NAME_WE) # only name without extension
set(QM_FILE "${FILENAME}.qm")       # name for the generated qm file
set(QM_FILES ${QM_FILES} "${CMAKE_CURRENT_BINARY_DIR}/${QM_FILE}")

add_custom_command(
	OUTPUT ${QM_FILE}
	COMMAND ${Qt5_LRELEASE_EXECUTABLE} ${LRELEASE_ARGS} ${TS_FILE} -qm ${CMAKE_CURRENT_BINARY_DIR}/${QM_FILE}
	COMMENT "Generating binary translation file ${QM_FILE}"
	DEPENDS ${TS_FILE}
	VERBATIM
)
endforeach()



#
# Add all translations to the binary via. rcc / qrc file
#

set(I18N_QRC_NAME translations)
set(I18N_QRC_INPUT ${CMAKE_CURRENT_LIST_DIR}/${I18N_QRC_NAME}.qrc)
set(I18N_QRC_COPY ${CMAKE_CURRENT_BINARY_DIR}/kaidan_i18n.qrc)
set(I18N_QRC_CPP ${CMAKE_CURRENT_BINARY_DIR}/qrc_kaidan_i18n.cpp)
set_property(SOURCE ${CMAKE_CURRENT_BINARY_DIR}/qrc_kaidan_i18n.cpp PROPERTY SKIP_AUTOGEN ON)

# Copy the QRC file to the output directory, because the files listed in the
# qrc file are relative to that directory.
add_custom_command(
	OUTPUT ${I18N_QRC_COPY}
	COMMAND ${CMAKE_COMMAND} -E copy ${I18N_QRC_INPUT} ${I18N_QRC_COPY}
	COMMENT "Copying i18n resource file to current build directory"
	MAIN_DEPENDENCY ${I18N_QRC_INPUT}
)

# Run the resource compiler (rcc_options should already be set). We can't
# use QT5_ADD_RESOURCES because the qrc file may not exist yet.
add_custom_command(
	OUTPUT ${I18N_QRC_CPP}
	COMMAND ${Qt5Core_RCC_EXECUTABLE} ${RCC_OPTIONS} -name ${I18N_QRC_NAME} -o ${I18N_QRC_CPP} ${I18N_QRC_COPY}
	COMMENT "Generating qrc source qrc_kaidan_i18n.cpp"
	MAIN_DEPENDENCY ${I18N_QRC_COPY}
	DEPENDS ${QM_FILES}
)


# Translatiopns target
add_custom_target(translations ALL DEPENDS ${TS_FILES} ${QM_FILES})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+add_compile_definitions(
+	QXMPP_DISABLE_DEPRECATED_BEFORE=0x010400
+)
+
 # set Kaidans sources (used in main cmake file)
 set(KAIDAN_SOURCES
 	src/main.cpp
@@ -50,6 +54,7 @@
 	src/ServerListModel.cpp
 	src/ServerListItem.cpp
 	src/AccountManager.cpp
+	src/VCardCache.cpp
 
 	# needed to trigger moc generation / to be displayed in IDEs
 	src/Enums.h

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2020 Linus Jahn <lnj@kaidan.im>
#
# SPDX-License-Identifier: CC0-1.0

include(ECMAddTests)

find_package(Qt5Test REQUIRED)

ecm_add_test(
	PresenceCacheTest.cpp
	../src/PresenceCache.cpp
	TEST_NAME PresenceCacheTest
	LINK_LIBRARIES Qt5::Test Qt5::Gui QXmpp::QXmpp
)

ecm_add_test(
	UserPresenceWatcherTest.cpp
	../src/PresenceCache.cpp
	TEST_NAME UserPresenceWatcherTest
	LINK_LIBRARIES Qt5::Test Qt5::Gui QXmpp::QXmpp
)

=== debian/changelog ===
kaidan (0.8.0-2) unstable; urgency=medium

  * Update maintainer to use the @alioth-lists.debian.net address.

 -- Aurélien COUDERC <coucouf@debian.org>  Thu, 27 Jan 2022 15:50:00 +0100

kaidan (0.8.0-1) experimental; urgency=medium

  [ Pino Toscano ]
  * Update the location in the watch file, the 0.7.0 bits were moved to the
    right structure.
  * Refer to common license file for Apache-2.0.
  * Re-export upstream signing key without extra signatures.

  [ Aurélien COUDERC ]
  * New upstream release (0.8.0).
    - Add typing notifications (XEP-0085: Chat State Notifications) (jbb)
    - Add message history syncing (XEP-0313: Message Archive Management) (lnj)
    - Window size is restored (melvo)
    - The server's website link is displayed if account creation is disabled
      (melvo)
    - Improved user strings & descriptions (melvo)
  * Update build dependencies according to the upstream build system:
    - QXmpp >= 1.3.0
    - add libkf5qqc2desktopstyle-dev
  * Refresh coyright information.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 31 May 2021 00:06:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: kaidan
 Section: net
 Priority: optional
-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
+Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
            Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>,
 Build-Depends: cmake (>= 3.3~),
@@ -9,7 +9,8 @@
                extra-cmake-modules (>= 5.40.0~),
                libgstreamer1.0-dev,
                libkf5notifications-dev (>= 5.67.0~),
-               libqxmpp-dev (>= 1.2.0~),
+               libkf5qqc2desktopstyle-dev (>= 5.67.0~),
+               libqxmpp-dev (>= 1.3.0~),
                libqt5svg5-dev (>= 5.14.0~),
                libzxingcore-dev,
                kirigami2-dev (>= 5.67.0~),

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ https://download.kde.org/unstable/@PACKAGE@/([\d.]+)/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
